#####################################################################
# 
# __init__.py - Zope Transactional Queue Initialisation
#
# $Id: __init__.py,v 1.2 2003/11/27 14:23:10 kevin Exp $
#
# Copyright (C) 2003 Kevin Gill
#
# Derived from the Xron version 0.0.10
# Copyright (C) 2000 Loren Stafford
#  
# Xron is Derived from the ZScheduler product version 0.0.7 in
# accord with the terms of the ZScheduler's license.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License  
# along with this program; if not, write to the 
#     Free Software Foundation, Inc., 
#     59 Temple Place - Suite 330, 
#     Boston, MA  02111-1307, USA.
# 
#####################################################################

""" Zope Transactional Queue Product - Initialisation

"""
import os

import zLOG

import TQPollingThread
import ZTxnQueue
import Dispatcher

gDispatcher=None

def initialize(context):
    global gDispatcher

    # Copied from Xron - If there is no TQPollingThread, create one
    app = context._ProductContext__app
    if hasattr(app, TQPollingThread.GlobalID):
        Manager = getattr(app, TQPollingThread.GlobalID)
    else:
        oManager=TQPollingThread.TQPollingThread(id=TQPollingThread.GlobalID, title='Polling Thread')
        app._setObject(TQPollingThread.GlobalID, oManager)
        get_transaction().note('Added Polling Thread')
        get_transaction().commit()
        Manager = getattr(app, TQPollingThread.GlobalID)

    # Register the Queue Class
    context.registerClass(
        ZTxnQueue.ZTxnQueue,
        permission='Add ZTxnQueue',
        constructors=(ZTxnQueue.manage_addZTxnQueueForm,
            ZTxnQueue.manage_addZTxnQueue),
        icon = "www/queue.gif")

    # Register Help
    context.registerHelp()
    context.registerHelpTitle('Transactional Queue')

    # Create background thread
    if not os.environ.get('ZTXNQUEUE_NO_CHECKTHREAD'):
        gDispatcher=Dispatcher.Dispatcher(target=Dispatcher.Timer, name='TQPollingThread',
            args=(TQPollingThread.GlobalID,))
    else:
        zLOG.LOG('TQPollingThread', zLOG.WARNING, "Warning - TQPollingThread is Disabled")
	
